
package Controls;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

/* Hilfsklasse fuer Malfeld, die ein Canvas mit Double-Buffering implementiert. */

class DBCanvas extends Canvas {

	private CB  cb;
	private int id;

	private int sizeX;
	private int sizeY;

	private boolean first = true;

	private Image buffer;
	private Graphics gBuffer = null;

	DBCanvas(CB cb, int id, int sizeX, int sizeY) {

		super();

		this.cb = cb;
		this.id = id;

		this.sizeX = sizeX;
		this.sizeY = sizeY;

		setSize(sizeX, sizeY);
	}

	public void paint(Graphics g) {

		if (first) { 

			buffer  = createImage(sizeX, sizeY);
			gBuffer = buffer.getGraphics();

			if (cb != null) cb.callback(id, this, null);

			first = false;
		}

		g.drawImage(buffer, 0, 0, null);
	}

	Graphics getGBuffer() {

		return gBuffer;
	}

	void showBuffer() {

		getGraphics().drawImage(buffer, 0, 0, null);
	}

	void reset(int sizeX, int sizeY, Color fg, Color bg) {

		this.sizeX = sizeX;
		this.sizeY = sizeY;

		setSize(sizeX, sizeY);

		setForeground(fg);
		setBackground(bg);

		buffer  = createImage(sizeX, sizeY);
		gBuffer = buffer.getGraphics();

		showBuffer();
	}

	public PixelGrabber getPixelGrabber(int x, int y, int w, int h, int[] pixels) {

		return(new PixelGrabber(buffer, x, y, w, h, pixels, 0, w)); 
	}
}
