
package Controls;

import java.awt.*;

/** Klasse zur Beschreibung von Maus-Aktionen. */

public class Maus {

	/** Maus-Aktion: keine. */
	public static final int NONE    = 0;
	/** Maus-Aktion: Clicked. */
	public static final int CLICK   = 1;
	/** Maus-Aktion: Entered. */
	public static final int ENTER   = 2;
	/** Maus-Aktion: Exited. */
	public static final int EXIT    = 3;
	/** Maus-Aktion: Pressed. */
	public static final int PRESS   = 4;
	/** Maus-Aktion: Released. */
	public static final int RELEASE = 5;
	/** Maus-Aktion: Dragged. */
	public static final int DRAG    = 6;
	/** Maus-Aktion: Moved. */
	public static final int MOVE    = 7;

	/** Typ der Maus-Aktion. */
	public int   typ;
	/** Ort der Maus-Aktion. */
	public Point loc;

	/**
	 * Erzeugt ein Maus-Objekt.
	 *
	 * @param typ	Typ der Maus-Aktion.
	 * @param loc	Ort der Maus-Aktion.
	 */

	public Maus(int typ, Point loc) {

		this.typ = typ;
		this.loc = loc;
	}

	/**
	 * Erzeugt ein Maus-Objekt.
	 *
	 * @param typ	Typ der Maus-Aktion.
	 * @param x	Ort der Maus-Aktion (X-Komponente).
	 * @param y	Ort der Maus-Aktion (Y-Komponente).
	 */

	public Maus(int typ, int x, int y) {

		this.typ = typ;
		this.loc = new Point(x, y);
	}

	/**
	 * Erzeugt ein Maus-Objekt.
	 *
	 * Ort der Maus-Aktion ist (0, 0).
	 * @param typ	Typ der Maus-Aktion.
	 */

	public Maus(int typ) {

		this(typ, 0, 0);
	}
}
