
import Controls.*;

import java.awt.*;

public class GUI extends CtrlPanel {

	Master master;

	public GUI(String name) {

		super(name, HORZ, NONE);

		master = new Master();

		Schalter farbig;
		Regler	 iteration = new Regler("Iterationen", HORZ, Master.ITER_MIN, Master.ITER_MAX, Master.ITER_INIT, master, Master.CB_ITER);

		MalFeld canvas = new MalFeld("MalFeld", 500, 400, Master.WIDTH, Master.HEIGHT, master, Master.CB_MAUS, Master.CB_INIT);
		Ausgabe msg    = new Ausgabe("Ausgabe", 7, 70);

		CtrlPanel xpanel  = new CtrlPanel("Ausgaben", VERT, RAND);

		xpanel.addItem(canvas);
		xpanel.addLast(msg, W);

		CtrlPanel cpanel  = new CtrlPanel("Controls",           VERT, RAND);
		CtrlPanel kpanel  = new CtrlPanel("Knoepfe",            VERT, RAND);
		CtrlPanel cpanel1 = new CtrlPanel("Default-Knoepfe",    HORZ, NONE);
		CtrlPanel cpanel2 = new CtrlPanel("Fraktal-Knoepfe",    VERT, NONE);
		CtrlPanel cpanel3 = new CtrlPanel("Julia-Knoepfe",      VERT, NONE);
		CtrlPanel cpanel4 = new CtrlPanel("Mand-Knoepfe",       VERT, NONE);

		cpanel1.addItem(new Knopf("Reset",   master, Master.CB_CLEAR));
		cpanel1.addLast(new Knopf("Quit",    master, Master.CB_QUIT));

		cpanel2.addItem(new Knopf("Koch",    master, Master.CB_KOCH));
		cpanel2.addItem(new Knopf("Baum",    master, Master.CB_BAUM));
		cpanel2.addItem(new Knopf("L-System",master, Master.CB_LSYS));
		cpanel2.addLast(new Eingabe("Regel fuer r","rurd",12,  master, Master.CB_LSYS_EINGABE));

		cpanel3.addItem(new Knopf("C",              master, Master.CB_KOMPLEX));
		cpanel3.addItem(new Knopf("Julia Rueck",    master, Master.CB_JULIA_RUECK));
		cpanel3.addItem(new Knopf("Julia Rand",     master, Master.CB_JULIA_RAND));
		cpanel3.addLast(new Knopf("Julia Voll",     master, Master.CB_JULIA_VOLL));

		cpanel4.addItem(new Knopf("Mand s",    master, Master.CB_MANDS));
		cpanel4.addItem(new Knopf("Mand s %",   master, Master.CB_MANDS_MOD));
		cpanel4.addItem(new Knopf("Fenster",   master, Master.CB_FENSTER));
		cpanel4.addItem(iteration);
		cpanel4.addLast(farbig = new Schalter("Farbig", false, master, Master.CB_FARBIG));

		kpanel.addItem(cpanel1);
		kpanel.addItem(cpanel2);
		kpanel.addItem(cpanel3);
		kpanel.addLast(cpanel4);

		cpanel.addLast(kpanel);

		addItem(xpanel);
		addLast(cpanel,N);

		master.setTargets(canvas, iteration, farbig, msg);	// Ziele setzen
	}
}
