
import Controls.*;

public class GUI extends CtrlPanel {

	public GUI(String name) {

		super(name, HORZ, NONE);

		Master master = new Master();

		Regler   faktor;
		Regler   dither;
		Auswahl  function;

		MalFeld canvas = new MalFeld("MalFeld", 500, 400, Master.WIDTH, Master.HEIGHT, master, Master.CB_MAUS, Master.CB_INIT);

		CtrlPanel cpanel  = new CtrlPanel("Controls", VERT, RAND);
		CtrlPanel kpanel  = new CtrlPanel("Knoepfe",  HORZ, RAND);

		kpanel.addItem(new Knopf("Clear", master, Master.CB_CLEAR));
		kpanel.addLast(new Knopf("Quit",  master, Master.CB_QUIT));

		cpanel.addItem(kpanel);

		String[] items = {"Punkt", "Linie", "Kreis", "Voll-Kreis", "Polygon", "Clip-Fenster"}; 
		cpanel.addItem(function = new Auswahl("Funktion", items, master, Master.CB_FUNCTION));

		cpanel.addItem(faktor = new Regler("Faktor", HORZ, Master.FAKTOR_MIN, Master.FAKTOR_MAX, Master.FAKTOR_INIT, master, Master.CB_FAKTOR));

		cpanel.addLast(dither = new Regler("Dither", HORZ, 0, Master.DITHER_MAX, Master.DITHER_INIT, master, Master.CB_DITHER));

		addItem(canvas);
		addLast(cpanel,N);

		master.setTargets(canvas, function, faktor, dither);
	}
}
