
package Controls;

import java.awt.*;

/** Allgemeine Konstanten fuer das Controls-Paket. */

public interface Ctrl {

	/** Default Padding fuer Boxen. */
	public static final int PAD  = 5;

	/** Default Vordergrund-Farbe. */
	public static final Color FG = Color.black;
	/** Default Hintergrund-Farbe. */
	public static final Color BG = Color.lightGray;

	/** Rand-Typ: kein Rand. */
	public static final int NONE = 0;
	/** Rand-Typ: einfacher Rand. */
	public static final int RAND = 1;
	/** Rand-Typ: Rand + Name. */
	public static final int NAME = 2;

	/** Orientierung: Horizontal. */
	public static final int HORZ = 0;
	/** Orientierung: Vertikal. */
	public static final int VERT = 1;

	/** Orientierung: Center. */
	public static final int C  = GridBagConstraints.CENTER;
	/** Orientierung: North. */
	public static final int N  = GridBagConstraints.NORTH;
	/** Orientierung: North-East. */
	public static final int NE = GridBagConstraints.NORTHEAST;
	/** Orientierung: East. */
	public static final int E  = GridBagConstraints.EAST;
	/** Orientierung: South-East. */
	public static final int SE = GridBagConstraints.SOUTHEAST;
	/** Orientierung: South. */
	public static final int S  = GridBagConstraints.SOUTH;
	/** Orientierung: South-West. */
	public static final int SW = GridBagConstraints.SOUTHWEST;
	/** Orientierung: West. */
	public static final int W  = GridBagConstraints.WEST;
	/** Orientierung: North-West. */
	public static final int NW = GridBagConstraints.NORTHWEST;

	/** File-Modus: LOAD. */
        public static final int LOAD = FileDialog.LOAD;
        /** File-Modus: SAVE. */
        public static final int SAVE = FileDialog.SAVE;

	/** File-Format: Standard-Java. (z.Zt. GIF oder JPEG) */
	public static final int STD  = 0;
	/** File-Format: PPM.
			Achtung, es wird nur ein eingeschraenkes PPM-Format akzeptiert:
				File muss P6 sein und der Header muss exakt folgendes Format haben:
				Keine Kommentare, exakt 3 Zeilen, Trenner zwischen den beiden Zahlen
				in der 2. Zeile ist genau ein Blank, kein zusaetzlicher White-Space. */
	public static final int PPM  = 1;
}
