package HelloWorld;

import java.awt.event.WindowListener;            // Importliste mit allen
import java.awt.event.WindowEvent;               // benoetigten Klassen aus
import java.awt.Dimension;                       // dem AWT und aus den
import java.awt.BorderLayout;                    
import javax.swing.UIManager;                    // Swing-Komponenten
import javax.swing.JFrame;

public class HelloApp implements WindowListener {
  /** Erzeugt eine Instanz der Klasse Hello. */
  public HelloApp() {
    try {                                        // Versuche Look & Feel so zu 
      UIManager.setLookAndFeel(                  // setzen, dass es auf allen 
					         // Systemen gleich aussieht
        UIManager.getCrossPlatformLookAndFeelClassName());
    } catch(Exception e) {};                     // sonst verwende default L&F

    JFrame frame = new JFrame("Hello");          // FensterObjekt erzeugen
                                                 // Instanz der Klasse Hello
                                                 // erzeugen und hinzufuegen
    frame.getContentPane().add(new Hello(), BorderLayout.CENTER);
    frame.addWindowListener(this);               // DIES Objekt ist fuer Window-
                                                 // Events zustaendig
    frame.pack();                                // anzeigbar machen und
                                                 // Fenstergroesse berechnen
    frame.setVisible(true);                      // Fenster sichtbar machen
  }

  /** Die folgenden Methoden gehoeren zum Interface WindowListener. 
   *  Der Rumpf bleibt bei allen Methoden (bis auf windowClosing) leer. */ 
  public void windowActivated(WindowEvent e) { }
  public void windowClosed(WindowEvent e) { }
  public void windowDeactivated(WindowEvent e) { }
  public void windowDeiconified(WindowEvent e) { }
  public void windowIconified(WindowEvent e) { }
  public void windowOpened(WindowEvent e) { }
  /** 
   * Sorgt dafuer, dass die Applikation beendet wird, wenn die entsprechende
   * Schaltflaeche im Rahmen des Fensters gedrueckt wurde.
   * @param e der ausgeloeste Event
   */
  public void windowClosing(WindowEvent e) {
    System.exit(0);                              // Programm sofort beenden
  }

  public static void main(String args[]) {
    new HelloApp();                              // Instanz erzeugen
  }
}
