#include <GL/glut.h>                                 /* OpenGl Utility Toolkit      */
#include <stdlib.h>                                  /* C-library                   */

int year = 0, day = 0;                               /* Variablen fuer Drehungen    */

void init(void) {
   glClearColor (0.0, 0.0, 1.0, 0.0);                /* blauer Hintergrund          */
   glShadeModel (GL_FLAT);                           /* Flatshading                 */
   glMatrixMode (GL_PROJECTION); glLoadIdentity ();  /* ab jetzt Projektion         */
   gluPerspective(60.0, 1.5, 1.0, 20.0);             /* Blickwinkel, w/h, near, far */
   glMatrixMode(GL_MODELVIEW); glLoadIdentity();     /* ab jetzt Modelview          */
   gluLookAt (0.0,0.0,5.0,0.0,0.0,0.0,0.0,1.0,0.0);  /* Kamera, Fokussier, Up-Vektor*/
}

void display(void){
   glClear (GL_COLOR_BUFFER_BIT);                       /* reset Pixels             */
   glColor3f (1.0, 1.0, 1.0);                           /* Farbe weiss              */
   glPushMatrix();                                      /* sichere Matrix           */
   glRotatef(30.0, 0.0, 1.0, 0.0);                      /* drehe 30 Grad um y       */
   glRotatef(30.0, 1.0, 0.0, 0.0);                      /* drehe 30 Grad um x       */
   glutWireSphere(1.0, 20, 16);                         /* zeichne die Sonne        */
   glRotatef ((GLfloat) year, 0.0, 1.0, 0.0);           /* Drehung um Sonne         */
   glTranslatef (2.0, 0.0, 0.0);                        /* Verschiebung von Sonne   */
   glRotatef ((GLfloat) day, 0.0, 1.0, 0.0);            /* Erd-Drehung              */
   glutWireSphere(0.2, 10, 8);                          /* zeichne die Erde         */
   glPopMatrix();                                       /* restauriere Matrix       */
   glutSwapBuffers();                                   /* tausche Puffer           */
}

void keyboard (unsigned char key, int x, int y){
   switch (key) {                                       /* abhaengig von der Taste  */
     case 'd': day =(day+10) % 360; break;              /* erhoehe Tag um 10        */
     case 'y': year=(year+5) % 360; break;}             /* erhoehe Jahr um 5        */
   glutPostRedisplay();                                 /* rufe display auf         */
}

int main (int argc, char ** argv) {          /* Hauptprogramm                       */
  glutInit(&argc, argv);                     /* initialisiere GLUT                  */
  glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB); /* double buffer, true color           */
  glutInitWindowSize(750, 500);              /* initiale Fenstergroesse             */
  glutInitWindowPosition(100,100);           /* initiale Fensterposition            */
  glutCreateWindow("planet");                /* Fenster mit Aufschrift              */
  init();                                    /* rufe init auf                       */
  glutDisplayFunc(display);                  /* registriere display                 */
  glutKeyboardFunc(keyboard);                /* registriere keyboard                */
  glutMainLoop();                            /* beginne Event-Schleife              */
  return 0;                                  /* ISO C verlangt Rueckgabe            */
}
