#include <GL/glut.h>                         /* Header fuer OpenGl utility toolkit  */
#include <stdlib.h>                          /* Header fuer C-Library               */

int fall=GL_POINTS;

void init(void) {                            /* Initialisierung                     */
  glClearColor(0.0, 0.0, 0.0, 0.0);          /* setze schwarz als Hintergrundfarbe  */
  glMatrixMode(GL_PROJECTION);               /* betrifft Projektionsmatrix          */
  glLoadIdentity();                          /* beginne mit Einheitsmatrix          */
  glOrtho(0.0, 7.5, 0.0, 5.0, -1.0, 1.0);    /* Orthogonalprojektions-Clip-Ebenen   */
}                                            /* left, right, bottom, top, near, far */

void display(void){                          /* Prozedur zum Zeichnen               */
  glClear(GL_COLOR_BUFFER_BIT);              /* alle Pixel zurecksetzen             */
  glMatrixMode(GL_MODELVIEW);                /* betrifft Modelview-Matrix           */
  glLoadIdentity();                          /* beginne mit Einheitsmatrix          */
  glColor3f(1.0, 0.0, 0.0);                  /* Farbe rot                           */ 
  glPolygonMode(GL_FRONT, GL_LINE);          /* zeichne Vorderseite, nur Linien     */
  glPointSize(5.0);
  glBegin(fall);                             /* Beginn einer Folge von Punkten      */
    glVertex2i(1,2); 
    glVertex2i(2,1); 
    glVertex2i(3,1); 
    glVertex2i(4,2);   
    glVertex2i(4,3); 
    glVertex2i(3,4); 
    glVertex2i(2,4); 
    glVertex2i(1,3);
  glEnd();                                   /* Ende einer Folge von Punkten        */ 
  glFlush();                                 /* direkt ausgeben                     */
}

void key(unsigned char key, int x, int y){
  switch(key) {
    case '0': fall=GL_POINTS;         break; /* Punkte                              */
    case '1': fall=GL_LINES ;         break; /* Gradenstuecke                       */
    case '2': fall=GL_LINE_STRIP;     break; /* Linienzug                           */
    case '3': fall=GL_LINE_LOOP;      break; /* geschlossener Linienzug             */
    case '4': fall=GL_TRIANGLES;      break; /* Dreiecke                            */
    case '5': fall=GL_TRIANGLE_STRIP; break; /* Streifen von Dreiecken              */
    case '6': fall=GL_TRIANGLE_FAN;   break; /* Faecher von Dreiecken               */
    case '7': fall=GL_QUADS;          break; /* Vierecke                            */
    case '8': fall=GL_QUAD_STRIP;     break; /* Streifen von Vierecken              */ 
    case '9': fall=GL_POLYGON;        break; /* Polygon                             */
  }
  glutPostRedisplay();
}
 
int main (int argc, char ** argv) {          /* Hauptprogramm                       */
  glutInit(&argc, argv);                     /* initialisiere GLUT                  */
  glutInitDisplayMode(GLUT_SINGLE|GLUT_RGB); /* single buffer, true color           */
  glutInitWindowSize(750, 500);              /* initiale Fenstergroesse             */
  glutInitWindowPosition(100,100);           /* initiale Fensterposition            */
  glutCreateWindow("punkte");                /* Fenster mit Aufschrift              */
  init();                                    /* rufe init auf                       */
  glutDisplayFunc(display);                  /* registriere display                 */
  glutKeyboardFunc(key);                     /* registriere key                     */
  glutMainLoop();                            /* beginne Event-Schleife              */
  return 0;                                  /* ISO C verlangt Rueckgabe            */
}
