#include <GL/glut.h>                         /* Header fuer OpenGl utility toolkit  */
#include <stdlib.h>                          /* Header fuer C-Library               */

void init (void)
{
   GLfloat light_ambient[]  = { 0.0, 0.0, 0.0, 1.0 };  /* Wert fuer ambientes Licht */
   GLfloat light_diffuse[]  = { 1.0, 1.0, 1.0, 1.0 };  /* Wert fuer diffuses Licht  */
   GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };  /* Wert fuer spekulares Licht*/         
   GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };  /* Wert fuer Lichtposition   */

   glLightfv (GL_LIGHT0, GL_AMBIENT,  light_ambient);  /* setze ambienten Wert      */
   glLightfv (GL_LIGHT0, GL_DIFFUSE,  light_diffuse);  /* setze diffusen Wert       */
   glLightfv (GL_LIGHT0, GL_SPECULAR, light_specular); /* setze spekularen Wert     */
   glLightfv (GL_LIGHT0, GL_POSITION, light_position); /* setze Positionswert       */
   
   glEnable (GL_LIGHTING);                             /* aktiviere Beleuchtung     */
   glEnable (GL_LIGHT0);                               /* aktiviere Lichtquelle 0   */
   glEnable (GL_DEPTH_TEST);                           /* aktiviere Tiefentest      */                  
}

void display (void)
{
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   glPushMatrix ();                               /* sichere Matrix                 */
   glRotatef (20.0, 1.0, 0.0, 0.0);               /* drehe 20 Grad um x-Achse       */

   glPushMatrix ();                               /* sichere Matrix                 */
   glTranslatef (-0.75, 0.5, 0.0);                /* verschiebe nach links oben     */
   glRotatef (90.0, 1.0, 0.0, 0.0);               /* drehe 90 Grad um x-Achse       */
   glutSolidTorus (0.275, 0.85, 15, 15);          /* zeichne Torus                  */
   glPopMatrix ();                                /* restauriere Matrix             */

   glPushMatrix ();                               /* sichere Matrix                 */
   glTranslatef (-0.75, -0.5, 0.0);               /* verschiebe nach links unten    */
   glRotatef (270.0, 1.0, 0.0, 0.0);              /* drehe 270 Grad um x-Achse      */
   glutSolidCone (1.0, 2.0, 15, 15);              /* zeichne Kegel                  */
   glPopMatrix ();                                /* restauriere Matrix             */

   glPushMatrix ();                               /* sichere Matrix                 */
   glTranslatef (0.75, 0.0, -1.0);                /* verschiebe nach rechts hinten  */
   glutSolidSphere (1.0, 15, 15);                 /* zeichne Kugel mit 15 Scheiben  */
   glPopMatrix ();                                /* restauriere Matrix             */

   glPopMatrix ();                                /* restauriere Matrix             */
   glFlush ();                                    /* direkt ausgeben                */
}

void reshape(int w, int h)
{
   GLfloat p = (GLfloat) w / (GLfloat) h;         /* Proportionalitaetsfaktor       */
   glViewport(0, 0, (GLsizei) w, (GLsizei) h);    /* setze Viewport                 */
   glMatrixMode (GL_PROJECTION);                  /* betrifft Projektionsmatrix     */
   glLoadIdentity ();                             /* lade Einheitsmatrix            */
   if (w <= h)                                    /* falls breiter als hoeher       */
     glOrtho(-2.5*p,2.5*p,-2.5,2.5,-10.0,10.0);   /* left,right,bottom,top,near,far */
   else                                           /* falls hoeher als breiter       */
     glOrtho(-2.5,2.5,-2.5/p,2.5/p,-10.0,10.0);   /* left,right,bottom,top,near,far */
   glMatrixMode (GL_MODELVIEW);                   /* betrifft Modelview-Matrix      */
   glLoadIdentity ();
}


int main (int argc, char ** argv) {               /* Hauptprogramm                  */
  glutInit(&argc, argv);                          /* initialisiere GLUT             */
  glutInitDisplayMode(GLUT_SINGLE|GLUT_RGB|GLUT_DEPTH);   /* single, RGB, tiefe     */
  glutInitWindowSize(500, 500);                   /* initiale Fenstergroesse        */
  glutInitWindowPosition(100,100);                /* initiale Fensterposition       */
  glutCreateWindow("scene");                      /* Fenster mit Aufschrift         */
  init();                                         /* rufe init auf                  */
  glutDisplayFunc(display);                       /* registriere display            */
  glutReshapeFunc(reshape);                       /* registriere reshape            */
  glutMainLoop();                                 /* beginne Event-Schleife         */
  return 0;                                       /* ISO C verlangt Rueckgabe       */
}