#include <GL/glut.h>                          /* Header fuer OpenGl utility toolkit */
#include <stdlib.h>                           /* Header fuer C-Library              */

void init(void) {
   glClearColor (0.0, 0.0, 0.0, 0.0);
   glColor3f(1.0,1.0,1.0);
   glShadeModel (GL_FLAT);
}

void display(void) {
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glPushMatrix();
   glRotatef(-40.0, 0.0, 1.0, 0.0);
   glRotatef( 20.0, 1.0, 0.0, 0.0); 
   glutWireTeapot(1.0);
   glPopMatrix(); glFlush ();
}

void reshape (int w, int h){
   GLfloat p = (GLfloat) w / (GLfloat) h;
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode (GL_PROJECTION); glLoadIdentity();
   if (p > 1.0) glOrtho(-1.5*p,1.5*p,-1.5,1.5,-10.0,10.0);
           else glOrtho(-1.5,1.5,-1.5/p,1.5/p,-10.0,10.0);
   glMatrixMode(GL_MODELVIEW); 
   glLoadIdentity();
}

int main(int argc, char** argv) {
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE|GLUT_RGB|GLUT_DEPTH);
   glutInitWindowSize (750, 500); 
   glutInitWindowPosition (100, 100);
   glutCreateWindow ("teapot-wire");
   init ();
   glutDisplayFunc(display); 
   glutReshapeFunc(reshape);
   glutMainLoop(); return 0;
}
