/*************************************************************************************/
/*                                                                                   */
/*                   Zeichnen einer Bezierkurve 3. Grades nach De Casteljau          */
/*                                                                                   */
/*************************************************************************************/

private void bezier(                            // Zeichne Bezierkurve 3. Grades
                     double px0, double py0,    // anhand des Stuetzpunktes p0
                     double px1, double py1,    // anhand des Stuetzpunktes p1
                     double px2, double py2,    // anhand des Stuetzpunktes p2
                     double px3, double py3,    // anhand des Stuetzpunktes p3
                     int depth)                 // aktuelle Rekursionstiefe
{
        double qx01,qy01,qx12,qy12,qx23,qy23,qx012,qy012,qx123,qy123,qx0123,qy0123;
                                                // Hilfspunkte

        if (depth > iter)                       // Iterationstiefe erreicht
             set_line(new Point( (int)px0, (int)py0), new Point( (int)px3, (int)py3));
        else {
                depth++;

                qx01   = (px0+px1)/2;     qy01   = (py0+py1)/2;
                qx12   = (px1+px2)/2;     qy12   = (py1+py2)/2;
                qx23   = (px2+px3)/2;     qy23   = (py2+py3)/2;
                qx012  = (qx01+qx12)/2;   qy012  = (qy01+qy12)/2;
                qx123  = (qx12+qx23)/2;   qy123  = (qy12+qy23)/2;
                qx0123 = (qx012+qx123)/2; qy0123 = (qy012+qy123)/2;

                bezier (px0,py0,qx01,qy01,qx012,qy012,qx0123,qy0123,depth);
                bezier (qx0123,qy0123,qx123,qy123,qx23,qy23,px3,py3,depth);
        }
}
