#include <GL/glut.h>                         /* Header fuer OpenGl utility toolkit  */
#include <stdlib.h>                          /* Header fuer C-Library               */

static GLfloat spin = 0.0;                   /* globale Variable fuer Winkel        */
 
void init(void) {                            /* Initialisierung                     */
  glClearColor(0.0, 0.0, 1.0, 0.0);          /* setze Blau als Hintergrundfarbe     */
  glShadeModel(GL_FLAT);                     /* Flatshading                         */
}

void display(void){                          /* Prozedur zum Zeichnen               */
  glClear(GL_COLOR_BUFFER_BIT);              /* alle Pixel zurecksetzen             */
  glPushMatrix();                            /* rette alten Matrizenstack           */
  glRotatef(spin, 0.0, 0.0, 1.0);            /* drehe spin Grad um z Achse          */
  glColor3f(1.0, 0.0, 0.0);                  /* Farbe rot                           */
  glRectf(-25.0, -25.0, 25.0, 25.0);         /* Rechteck                            */
  glPopMatrix();                             /* restauriere Matrizenstack           */
  glutSwapBuffers();                         /* wechselt die Puffer                 */
}

void spinDisplay(void) {                     /* modifiere Drehwinkel                */
  spin = spin + 2.0;                         /* erhoehe den Winkel um 2 Grad        */
  if (spin > 360.0) spin = spin-360.0;       /* bei Ueberlauf: von vorn             */
  glutPostRedisplay();                       /* rufe display auf                    */
}


void reshape(int w, int h) {                 /* bei Aendern der Fenstergroesse      */
  glViewport(0,0,(GLsizei)w, (GLsizei)h);    /* neuer Viewport Breite w, Hoehe h    */
  glMatrixMode(GL_PROJECTION);               /* ab jetzt: Projektionsmatrix         */
  glLoadIdentity();                          /* lade Einheitsmatrix                 */
  glOrtho(-50.0,50.0,-50.0,50.0,-1.0,1.0);   /* left, right, bottom, top, near, far */
  glMatrixMode(GL_MODELVIEW);                /* ab jetzt:  Modellierungsmatrix      */
  glLoadIdentity();                          /* Lade Einheitsmatrix                 */
}

void mouse(int button, int state,            /* Aufruf bei Maus-Klick               */ 
           int x, int y) {                   /* bei Koordinate x,y                  */
  switch(button) {                           /* analysiere den Mausevent            */
    case GLUT_LEFT_BUTTON:                   /* falls linke Taste                   */
      if (state==GLUT_DOWN)                  /* gedrueckt                           */
        glutIdleFunc(spinDisplay);           /* startet spinDisplay im Hintergrund  */
      break;
    case GLUT_MIDDLE_BUTTON:                 /* falls mittlere Taste                */
    case GLUT_RIGHT_BUTTON:                  /* falls rechte Taste                  */
      if (state==GLUT_DOWN)                  /* gedrueckt                           */
        glutIdleFunc(NULL);                  /* beende Hintergrundprozess           */
      break;
    default: break;
  }
}

int main (int argc, char ** argv) {          /* Hauptprogramm                       */
  glutInit(&argc, argv);                     /* initialisiere GLUT                  */
  glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB); /* single buffer, true color           */ 
  glutInitWindowSize(250, 250);              /* initiale Fenstergroesse             */
  glutInitWindowPosition(100,100);           /* initiale Fensterposition            */
  glutCreateWindow("cube");                  /* Fenster mit Aufschrift              */
  init();                                    /* rufe init auf                       */
  glutDisplayFunc(display);                  /* registriere display                 */
  glutReshapeFunc(reshape);                  /* registriere reshape                 */
  glutMouseFunc(mouse);                      /* registriere mouse                   */
  glutMainLoop();                            /* beginne Event-Schleife              */
  return 0;                                  /* ISO C verlangt Rueckgabe            */
}

