/*************************************************************************************/
/*                                                                                   */
/*                   Fuellen einer durch Vordergrundfarbe umrandeten Flaeche         */
/*                                                                                   */
/*************************************************************************************/

private void boundary_fill(             // setzt alle Nicht-Vordergrund-Pixel
                           Point p)     // beginnend bei Position p auf Vordergrund
{
        if ( range_ok(p) && !get_pixel(p) ) {    // falls p keine Vordergrundfarbe hat

                set_pixel(p);                    // setze Vordergrundfarbe

                boundary_fill( new Point(p.x+1, p.y   ));  // 4-way stepping
                boundary_fill( new Point(p.x,   p.y+1 ));
                boundary_fill( new Point(p.x-1, p.y   ));
                boundary_fill( new Point(p.x,   p.y-1 ));

        }
}




/*************************************************************************************/
/*                                                                                   */
/*                   Leeren einer durch Vordergrundfarbe definierten Flaeche         */
/*                                                                                   */
/*************************************************************************************/

private void boundary_empty(            // setzt alle Vordergrund-Pixel beginnend 
                            Point p)    // bei Position p auf Hintergrundfarbe
{
        if ( range_ok(p) && get_pixel(p) ) {    // falls p Vordergrundfarbe hat

                del_pixel(p);                   // setze Hintergrundfarbe

                boundary_empty( new Point( p.x+1, p.y   ));  // 8-way-stepping
                boundary_empty( new Point( p.x+1, p.y+1 ));
                boundary_empty( new Point( p.x,   p.y+1 ));
                boundary_empty( new Point( p.x-1, p.y+1 ));
                boundary_empty( new Point( p.x-1, p.y   ));
                boundary_empty( new Point( p.x-1, p.y-1 ));
                boundary_empty( new Point( p.x,   p.y-1 ));
                boundary_empty( new Point( p.x+1, p.y-1 ));

        }
}
