/************************************************************************************/
/*                           Mandelbrotmenge                                        */
/************************************************************************************/
void  mandel(                   // berechnet und zeichnet Mandelbrotmenge ab 
        Komplex start,          // linker oberer Ecke start der komplexen Flaeche
        double  schritt,        // mit Schrittweite schritt und 
        int     max_iter,       // Iterationsanzahl max_iter (muss gerade sein)
        int     fall)           // gemaess Fall fall
                                // Abbruch, wenn Quadrat des Betrags >= 4 
                                // oder wenn Iterationszahl erreicht ist 
{
    Komplex c = new Komplex(0.0, 0.0);
    Komplex z = new Komplex(0.0, 0.0);
    Point   p = new Point();
    double  q_betrag, tmp;
    int     zaehler ;

    for (p.x = 0, c.re = start.re; p.x < WIDTH;  p.x++, c.re += schritt) 
    for (p.y = 0, c.im = start.im; p.y < HEIGHT; p.y++, c.im += schritt) 
    {
        z.re = 0.0;
        z.im = 0.0;
        zaehler = 0;
        q_betrag  = 0.0;

        while( (q_betrag < 4.0)  && (zaehler++ < max_iter) ) {
                tmp    = z.re;
                z.re   = z.re * z.re - z.im * z.im + c.re;
                z.im   = 2 * tmp * z.im + c.im;
                q_betrag = z.re*z.re + z.im*z.im;
        }
                
        switch (fall) {

        case 1: if (q_betrag(z) < 4.0) set_pixel(p); break;       // schwarz

        case 2: if (q_betrag(z) < 4.0) set_pixel(p); else         // schwarz
                if ((zaehler %2) != 0) set_pixel(p); break;       // mit modulo

        case 3: if(zaehler == max_iter+1)
                set_col_pixel(p,farbe[0]); else                   // Mandelbrotmenge
                set_col_pixel(p,farbe[zaehler%NUM_COL]); break;   // farbe modulo
        }
    }
}
